﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        [DllImport("user32.dll")]
        static extern IntPtr GetOpenClipboardWindow();

        [DllImport("user32.dll", SetLastError = true)]
        static extern uint GetWindowThreadProcessId(IntPtr hWnd, out uint lpdwProcessId);

        [DllImport("user32.dll")]
        static extern IntPtr GetClipboardOwner();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Thread t = new Thread(checkLoop);
            t.IsBackground = true;
            t.Start();
        }

        private void checkLoop()
        {
            while (true)
            {
                Thread.Sleep(1000 * 2);

                this.btnLock.BeginInvoke( (WaitCallback)( (arg) =>
                {
                    BtnOwner_Click(this.btnOwner, EventArgs.Empty);
                }), this);
            }
        }

        [DllImport("user32.dll", SetLastError = true)]
        static extern bool CloseClipboard();

        [DllImport("user32.dll", SetLastError = true)]
        static extern bool OpenClipboard(IntPtr hWndNewOwner);

        bool _opened = false;

        private void Button1_Click(object sender, EventArgs e)
        {
            _opened = OpenClipboard(this.Handle);
            this.Text = _opened.ToString();
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            if (_opened == true)
            {
                CloseClipboard();
            }
        }

        private void BtnOwner_Click(object sender, EventArgs e)
        {
            this.textBox1.Text = "(clipboard - no owner)";
            IntPtr pClipboardOwner = GetOpenClipboardWindow();
            //if (pClipboardOwner == IntPtr.Zero)
            //{
            //    pClipboardOwner = GetClipboardOwner();
            //}

            if (pClipboardOwner == IntPtr.Zero)
            {
                return;
            }

            GetWindowThreadProcessId(pClipboardOwner, out uint dwProcessId);
     //       Process owner = Process.GetProcessById((int)dwProcessId);
     //       string name = owner.ProcessName;
      //      string mainModule = owner.MainModule.FileName;

            textBox1.Text = $"{dwProcessId}, " + GetProcessInfo(dwProcessId);
        }

        string GetProcessInfo(uint processId)
        {
            string arg = $"process where \"ProcessID={processId}\" get ExecutablePath";
            return GetOutput("wmic", arg);
        }

        private static string GetOutput(string executable, string arguments)
        {
            ProcessStartInfo psi = new ProcessStartInfo();
            psi.FileName = executable;
            psi.Arguments = arguments;
            psi.RedirectStandardOutput = true;
            psi.UseShellExecute = false;
            psi.CreateNoWindow = true;

            Process proc = Process.Start(psi);
            string txt = proc.StandardOutput.ReadToEnd();
            return txt;
        }
    }
}
